<%@ Register TagPrefix="Acme" TagName="SourceRef" Src="/quickstart/util/SrcRef.aspx"%>

<!-- #include virtual="/quickstart/howto/include/header.inc" -->

<script language="C#" runat="server">

    public void Page_Load(Object sender, EventArgs E) 
    {
        // shell the explorer to a directory
        Ref.RunSample = Server.MapPath("/quickstart/howto/samples/net/WebRequests");

        // run an aspx page directly
        // Ref.RunSample = "/quickstart/howto/samples/BaseDataTypes/Sort/Sort.aspx";

        Ref.ViewSource = "/quickstart/howto/samples/net/WebRequests/clientGETasync.src";
        Ref.Icon = "/quickstart/images/genicon.gif";
        Ref.Caption = "ClientGETasync.exe";
    }

</script>

<h4>How Do I...Make a GET request asynchronously?</h4>

<div class="indent" style="width:660">
<P>
This sample illustrates using the WebRequest and WebResponse classes to make a GET request on a URI asynchronously.
</P>
<P>
This sample is similar to the other WebRequest samples, with the difference found in the <I>Begin</I> and <I>End</i> async-style function calls. Put simply, instead of calling <B>GetResponse</B> a call is made to the function <B>BeginGetResponse</B>, with the callback function sent as a parameter.
</P>
<P>
This function <B>RespCallback</B>, takes an object of type <B>IASyncResult</B>. This object contains an object <B>AsyncObject</B> that can be cast as a <B>HttpWebRequest</B>. Calling this casted objects <B>EndGetResponse</B> method will return a WebResponse object (which is cast as an HttpWebResponse in this case.)
</P>
<P>
From here, this example is like the others. It pulls out the response from the stream and writes it out to the console. However, this example is using the StreamReader and StreamWriter classes to do this.
</p>
</div>

<h4>Example</h4>

<Acme:SourceRef id="Ref" runat="server" />

<h4>Source Code</h4>

<div class="code">
<xmp>
<!-- #include virtual="/quickstart/howto/samples/net/WebRequests/clientGETasync.cs" -->
</xmp>
</div>

<!-- #include virtual="/quickstart/howto/include/footer.inc" -->
