<!-- #include virtual="/quickstart/howto/doc/xml/header.inc" -->

<h4>XML Frameworks</h4>
<div class="indent" style="width:660">XML is a meta-markup language that provides a format for describing
structured data. XML enables a new generation of Web-based data viewing and manipulation applications.
  Extensible Markup Language (XML) is the universal language for data on the 
Web. XML gives developers the power to deliver structured data from a wide 
variety of applications to the desktop for local computation and presentation.</div>

<h4>System.NewXml Namespace</h4>

<div class="indent" style="width:660">
This set of topics cover the usage of the XML classes in the System.NewXml namespace.
<p>This namespace has a comprehensive set of XML classes for parsing, validation and
manipulation of XML data using readers, writers and W3C DOM compliant
components. It also covers XPath queries and XSL transformations.
The following list contains the main classes we will be working with.</div>

<ul>
<LI>The <b>XmlTextReader</b> class provides fast, non-cached, forward only read access to XML data.
<LI>The <b>XmlTextWriter</b> class provides a fast, forward only way of generating
  XML. 
<LI>The <b>XmlDocument</b> class implements the <A href="http://www.w3.org/TR/REC-DOM-Level-1/level-one-core.html">W3C Document object Model level 1 Core</A> and the 
<A href="http://www.w3.org/TR/DOM-Level-2/core.html">Core DOM Level 2</A> 
<LI>The <b>DocumentNavigator</b> and <b>DataDocumentNavigator</b> classes provide a cursor style model to navigate an XML in-memory tree and support XPath 
expressions. These are implementations of the XmlNavigator class.
<LI>The <b>XslTransform</b> class loads an XSLT stylesheet and transforms the input data using an
  XmlNavigator. 
</LI>
<LI>The <b> XmlDataDocument</b> class provides an implementation of an
  XmlDocument that can be associated with a DataSet. Structured XML can be
  viewed and manipulated simultaneously through the DataSet's relational
  representation or the XmlDataDocument's tree representation. See the topic <A target=content href="XMLDataSet.aspx">How Do I...Use XML and the DataSet class?</A>  
</LI>
</ul>

<h4>World Wide Web Consortium (W3C) Conformance</h4>

<div class="indent" style="width:660">
The classes in this namespace are written to be conformant with the <A href="http://www.w3.org">World Wide Web Consortium (W3C)</A> specifications and so provide a
comprehensive set of XML tools for building Web applications or any other scenario where XML is used for information inter-change.</div>

<!-- #include virtual="/quickstart/howto/include/footer.inc" -->

