
<%@ Register TagPrefix="Acme" TagName="SourceRef" Src="/quickstart/util/SrcRef.aspx"%>

<!-- #include virtual="/quickstart/include/header.inc" -->

<h4>ADO+: Handling Errors</h4>
<p>
<hr>
In addition to Try/Catch and exceptions, the new ADO+ data architecture allows you to add error messages to each row of Data in a DataSet. SQLDatasetCommands attaches error messages to Rows if updates or other actions fail. Furthermore, you can filter for rows in error to present them to the user, or pass them to error handling functions.
<p>
Errors persist with the DataSet even when being tranferred using XML or Web Services. It is easy to set the Error message of a DataRow in a DataSet using the RowError property.
<p>
<div class=code>
myDataSet.Tables["Customers"].Rows[0].RowError = "This is an error mesage";
</div>
<p>
Now you can walk the error in a DataTable with the GetErrors() method. You can also test for errors using HasErrors .
<div class=code>
<br>if (dsCustomers.Tables["Customers"].HasErrors())
<br>{
<br>for each Customer in dsCustomers.Tables["Customers"].GetErrors();
<br>{
<br>Response.Write(Customer.RowError)
<br>}
<br>}
</div>
<p>
The following example loads a DataSet, sets some errors, and then shows the Errors in the Rows.
<p>

<Acme:SourceRef 
  RunSample="/quickstart/howto/samples/adoplus/cs/HandleErrors.aspx" 
  ViewSource="/quickstart/howto/samples/adoplus/cs/HandleErrors.src"
  Icon="/quickstart/images/genicon.gif"
  Caption="HandleErrors.aspx"
  runat="server" />
</a>
