
<%@ Register TagPrefix="Acme" TagName="SourceRef" Src="/quickstart/util/SrcRef.aspx"%>

<!-- #include virtual="/quickstart/include/header.inc" -->

<h4>ADO+: Working with Typed Data</h4>
<p> ADO provides late-bound access to values within its recordset through weakly typed variables. ADO+ provides the ability to access the data held in the DataSet through a "strongly typed" metaphor. 
This means you can access tables and columns that are part of the DataSet with user-friendly names and strongly typed variables. Therefore, rather then writing :

<div class="code">

<br>	AdoRecordset.Find("Customerid = 'ALFKI'");
	AdoRecordSet.Fields["FirstName"].Value  = "Bob";  </br>
</div>

<P>with a strongly typed DataSet you write:</P>


<div class="code">

<br>   CustomerDataSet.Customers["ALFKI"].CustomerName = "Bob";<br>
</div>


<P>Additionally, the strongly typed DataSet provides access to row values as the correct, strongly typed, value. In using ADO, variant types are used  when assigning and retrieving data. If the value that you assigned was of the wrong type, ADO would give you a run-time error. With ADO+, if the value is of type integer, and you attempt to assign a string, you will get a compile-time error.</P>
<P>Given an XML schema that complies with the XSD standard, you can generate a strongly typed DataSet using the XSD.exe tool provided with this SDK. The syntax for generating a dataset using this tool is:</P>

<div class="code">
   xsd.exe /d /l:C# {XSDSchemaFileName.xsd}
</div>

<p> The /d directive directs the tool to generate a DataSet; the /l: directive specifies the language to use--either "C#" or "VB."</P>

<P> The example below uses a strongly typed dataset called "customerDataSet" to load a list of customers from the Northwind database. Once the data is loaded using the FillDataSet method, the code loops through each customer in the "customers" table using the typed customerRow object. Note 
the direct access to the "customerid" field, as opposed to accessing it through the Fields collection.</P>


<p>
<hr>
<Acme:SourceRef 
  RunSample="/quickstart/howto/samples/adoplus/cs/TypedData.aspx" 
  ViewSource="/quickstart/howto/samples/adoplus/cs/TypedData.src"
  Icon="/quickstart/images/genicon.gif"
  Caption="TypedData.aspx"
  runat="server" />
</a>
