<%@ Page Language="C#" %>
<%@ Import Namespace="System.Text" %>
<%@ Import Namespace="System.IO" %>
<%@ Import Namespace="System.Globalization" %>

<%@ Register TagPrefix="Acme" TagName="SourceView" Src="/quickstart/samples/util/SrcView.aspx"%>

<html>
<head>
<link rel="stylesheet" href="/quickstart/samples/util/style.css" >

    <script runat="server">

      public void Page_Load (Object sender, EventArgs E)
      {
	StringBuilder output = new StringBuilder();
        
        //Simple DateTime parsing 
	Console.WriteLine();
	String date = "03/17/77";
  	output.Append("Parsing ");
	output.Append(date + ".\n");	
	DateTime d = DateTime.Parse(date);
	output.Append("The date parsed as ");
	output.Append(d.ToString() + ".\n\n");
	//DateTime parsing using ParseExact 
	String date2 = "Thursday, March 17, 1977";
  	output.Append("Parsing ");
	output.Append(date2 + ".\n");
	DateTime d2 = DateTime.ParseExact(date2,"D", null);
	output.Append("The date parsed as ");
	output.Append(d2.ToString() + ".\n\n");

	//Simple numeric parsing
	String toBeParsed = "123456";
	output.Append("Parsing the string "+toBeParsed+".\n");
	int i = Int32.Parse(toBeParsed);
	output.Append("The string parsed to "+i.ToString()+".\n\n");
	
	//Parsing using NumberStyles
	String toBeParsed2 = "  (123456)";
	output.Append("Parsing the string"+ toBeParsed2 +" which contains leading white space and parens.\n");
	int j = Int32.Parse(toBeParsed2, NumberStyles.AllowParentheses|NumberStyles.AllowLeadingWhite);
	output.Append("The string parsed to "+i+".\n");

	TxtOutput.Value=output.ToString();
      }

    </script>

</head>
<body>

<h3>Parse.aspx</h3>

<h4>Output: </h4>
<textarea id="TxtOutput" cols="80" rows="20" runat="server"/>

</body>
</html>
