namespace customerDataSet {
    using System;
    using System.Data;
    using System.Core;
    
    public class customerDataSet : DataSet {
        private int tableCount;
        private int relationCount;
        private customers tablecustomers;
        
        public customerDataSet() {
            this.InitClass();
        }
        
        public customers customers {
            virtual get {
                return this.tablecustomers;
            }
        }
        
        private void InitClass() {
            this.DataSetName = "custds";
            this.tableCount = 1;
            this.relationCount = 0;
            this.tablecustomers = new customers("customers");
            this.Tables.Add(this.tablecustomers);
        }
        protected override bool HasSchemaChanged() {
            return ((((this.tableCount) != (this.Tables.Count))) || (((this.relationCount) != (this.Relations.Count))));
        }
        protected override void OnRemoveTable(DataTable table) {
            if (((table) == (this.tablecustomers))) {
                throw new ArgumentException("Can't remove relation since it it built in to this dataSet");
            }
        }
        
    }
    public class customers : DataTable, System.Collections.ICollection {
        private int columnCount;
        private customers_CustomerID columnCustomerID;
        private customers_CompanyName columnCompanyName;
        private customers_ContactName columnContactName;
        private customers_ContactTitle columnContactTitle;
        private customers_Address columnAddress;
        private customers_City columnCity;
        private customers_Region columnRegion;
        private customers_PostalCode columnPostalCode;
        private customers_Country columnCountry;
        private customers_Phone columnPhone;
        private customers_Fax columnFax;
        private DataColumn[] indexByCustomerID;
        private customersRowChangeEventHandler customersRowChanged;
        private customersRowChangeEventHandler customersRowChanging;
        private DataColumnChangeEventHandler CustomerIDColumnChanging;
        private DataColumnChangeEventHandler CompanyNameColumnChanging;
        private DataColumnChangeEventHandler ContactNameColumnChanging;
        private DataColumnChangeEventHandler ContactTitleColumnChanging;
        private DataColumnChangeEventHandler AddressColumnChanging;
        private DataColumnChangeEventHandler CityColumnChanging;
        private DataColumnChangeEventHandler RegionColumnChanging;
        private DataColumnChangeEventHandler PostalCodeColumnChanging;
        private DataColumnChangeEventHandler CountryColumnChanging;
        private DataColumnChangeEventHandler PhoneColumnChanging;
        private DataColumnChangeEventHandler FaxColumnChanging;
        
        public customers(string name) : 
                base(name) {
            this.InitClass();
        }
        
        public int Count {
            virtual get {
                return this.Rows.Count;
            }
        }
        public bool IsReadOnly {
            virtual get {
                return false;
            }
        }
        public bool IsSynchronized {
            virtual get {
                return false;
            }
        }
        public object SyncRoot {
            virtual get {
                return this;
            }
        }
        public customers_CustomerID CustomerIDColumn {
            virtual get {
                return this.columnCustomerID;
            }
        }
        public customers_CompanyName CompanyNameColumn {
            virtual get {
                return this.columnCompanyName;
            }
        }
        public customers_ContactName ContactNameColumn {
            virtual get {
                return this.columnContactName;
            }
        }
        public customers_ContactTitle ContactTitleColumn {
            virtual get {
                return this.columnContactTitle;
            }
        }
        public customers_Address AddressColumn {
            virtual get {
                return this.columnAddress;
            }
        }
        public customers_City CityColumn {
            virtual get {
                return this.columnCity;
            }
        }
        public customers_Region RegionColumn {
            virtual get {
                return this.columnRegion;
            }
        }
        public customers_PostalCode PostalCodeColumn {
            virtual get {
                return this.columnPostalCode;
            }
        }
        public customers_Country CountryColumn {
            virtual get {
                return this.columnCountry;
            }
        }
        public customers_Phone PhoneColumn {
            virtual get {
                return this.columnPhone;
            }
        }
        public customers_Fax FaxColumn {
            virtual get {
                return this.columnFax;
            }
        }
        public customersRow this[int index] {
            virtual get {
                return (customersRow)(this.Rows[index]);
            }
        }
        
        public virtual void AddcustomersRow(customersRow rowcustomersRow) {
            this.Rows.Add(rowcustomersRow);
        }
        public virtual customersRow AddcustomersRow(string columnCustomerID, string columnCompanyName, string columnContactName, string columnContactTitle, string columnAddress, string columnCity, string columnRegion, string columnPostalCode, string columnCountry, string columnPhone, string columnFax) {
            customersRow rowcustomersRow;
            rowcustomersRow = (customersRow)(this.NewRow());
            rowcustomersRow.ItemArray = new Object[] {columnCustomerID, columnCompanyName, columnContactName, columnContactTitle, columnAddress, columnCity, columnRegion, columnPostalCode, columnCountry, columnPhone, columnFax};
            this.Rows.Add(rowcustomersRow);
            return rowcustomersRow;
        }
        public virtual void AddOncustomersRowChanged(customersRowChangeEventHandler handler) {
            this.customersRowChanged = (customersRowChangeEventHandler)(Delegate.Combine(this.customersRowChanged, handler));
        }
        public virtual void AddOncustomersRowChanging(customersRowChangeEventHandler handler) {
            this.customersRowChanging = (customersRowChangeEventHandler)(Delegate.Combine(this.customersRowChanging, handler));
        }
        public virtual void RemoveOncustomersRowChanged(customersRowChangeEventHandler handler) {
            this.customersRowChanged = (customersRowChangeEventHandler)(Delegate.Remove(this.customersRowChanged, handler));
        }
        public virtual void RemoveOncustomersRowChanging(customersRowChangeEventHandler handler) {
            this.customersRowChanging = (customersRowChangeEventHandler)(Delegate.Remove(this.customersRowChanging, handler));
        }
        public virtual void AddOnCustomerIDColumnChanging(DataColumnChangeEventHandler handler) {
            this.CustomerIDColumnChanging = (DataColumnChangeEventHandler)(Delegate.Combine(this.CustomerIDColumnChanging, handler));
        }
        public virtual void RemoveOnCustomerIDColumnChanging(DataColumnChangeEventHandler handler) {
            this.CustomerIDColumnChanging = (DataColumnChangeEventHandler)(Delegate.Remove(this.CustomerIDColumnChanging, handler));
        }
        public virtual void AddOnCompanyNameColumnChanging(DataColumnChangeEventHandler handler) {
            this.CompanyNameColumnChanging = (DataColumnChangeEventHandler)(Delegate.Combine(this.CompanyNameColumnChanging, handler));
        }
        public virtual void RemoveOnCompanyNameColumnChanging(DataColumnChangeEventHandler handler) {
            this.CompanyNameColumnChanging = (DataColumnChangeEventHandler)(Delegate.Remove(this.CompanyNameColumnChanging, handler));
        }
        public virtual void AddOnContactNameColumnChanging(DataColumnChangeEventHandler handler) {
            this.ContactNameColumnChanging = (DataColumnChangeEventHandler)(Delegate.Combine(this.ContactNameColumnChanging, handler));
        }
        public virtual void RemoveOnContactNameColumnChanging(DataColumnChangeEventHandler handler) {
            this.ContactNameColumnChanging = (DataColumnChangeEventHandler)(Delegate.Remove(this.ContactNameColumnChanging, handler));
        }
        public virtual void AddOnContactTitleColumnChanging(DataColumnChangeEventHandler handler) {
            this.ContactTitleColumnChanging = (DataColumnChangeEventHandler)(Delegate.Combine(this.ContactTitleColumnChanging, handler));
        }
        public virtual void RemoveOnContactTitleColumnChanging(DataColumnChangeEventHandler handler) {
            this.ContactTitleColumnChanging = (DataColumnChangeEventHandler)(Delegate.Remove(this.ContactTitleColumnChanging, handler));
        }
        public virtual void AddOnAddressColumnChanging(DataColumnChangeEventHandler handler) {
            this.AddressColumnChanging = (DataColumnChangeEventHandler)(Delegate.Combine(this.AddressColumnChanging, handler));
        }
        public virtual void RemoveOnAddressColumnChanging(DataColumnChangeEventHandler handler) {
            this.AddressColumnChanging = (DataColumnChangeEventHandler)(Delegate.Remove(this.AddressColumnChanging, handler));
        }
        public virtual void AddOnCityColumnChanging(DataColumnChangeEventHandler handler) {
            this.CityColumnChanging = (DataColumnChangeEventHandler)(Delegate.Combine(this.CityColumnChanging, handler));
        }
        public virtual void RemoveOnCityColumnChanging(DataColumnChangeEventHandler handler) {
            this.CityColumnChanging = (DataColumnChangeEventHandler)(Delegate.Remove(this.CityColumnChanging, handler));
        }
        public virtual void AddOnRegionColumnChanging(DataColumnChangeEventHandler handler) {
            this.RegionColumnChanging = (DataColumnChangeEventHandler)(Delegate.Combine(this.RegionColumnChanging, handler));
        }
        public virtual void RemoveOnRegionColumnChanging(DataColumnChangeEventHandler handler) {
            this.RegionColumnChanging = (DataColumnChangeEventHandler)(Delegate.Remove(this.RegionColumnChanging, handler));
        }
        public virtual void AddOnPostalCodeColumnChanging(DataColumnChangeEventHandler handler) {
            this.PostalCodeColumnChanging = (DataColumnChangeEventHandler)(Delegate.Combine(this.PostalCodeColumnChanging, handler));
        }
        public virtual void RemoveOnPostalCodeColumnChanging(DataColumnChangeEventHandler handler) {
            this.PostalCodeColumnChanging = (DataColumnChangeEventHandler)(Delegate.Remove(this.PostalCodeColumnChanging, handler));
        }
        public virtual void AddOnCountryColumnChanging(DataColumnChangeEventHandler handler) {
            this.CountryColumnChanging = (DataColumnChangeEventHandler)(Delegate.Combine(this.CountryColumnChanging, handler));
        }
        public virtual void RemoveOnCountryColumnChanging(DataColumnChangeEventHandler handler) {
            this.CountryColumnChanging = (DataColumnChangeEventHandler)(Delegate.Remove(this.CountryColumnChanging, handler));
        }
        public virtual void AddOnPhoneColumnChanging(DataColumnChangeEventHandler handler) {
            this.PhoneColumnChanging = (DataColumnChangeEventHandler)(Delegate.Combine(this.PhoneColumnChanging, handler));
        }
        public virtual void RemoveOnPhoneColumnChanging(DataColumnChangeEventHandler handler) {
            this.PhoneColumnChanging = (DataColumnChangeEventHandler)(Delegate.Remove(this.PhoneColumnChanging, handler));
        }
        public virtual void AddOnFaxColumnChanging(DataColumnChangeEventHandler handler) {
            this.FaxColumnChanging = (DataColumnChangeEventHandler)(Delegate.Combine(this.FaxColumnChanging, handler));
        }
        public virtual void RemoveOnFaxColumnChanging(DataColumnChangeEventHandler handler) {
            this.FaxColumnChanging = (DataColumnChangeEventHandler)(Delegate.Remove(this.FaxColumnChanging, handler));
        }
        public virtual void CopyTo(Array array, int offset) {
            for (int i = 0; ((i) < (this.Rows.Count)); i = ((i) + (1))) {
                array.SetValue(this.Rows[i], ((i) + (offset)));
            }
        }
        public virtual customersRow FindByCustomerID(string columnCustomerID) {
            return (customersRow)(this.FindRow(this.indexByCustomerID, new Object[] {columnCustomerID}));
        }
        public virtual System.Collections.IEnumerator GetEnumerator() {
            return this.Rows.All.GetEnumerator();
        }
        public virtual System.Collections.IEnumerator GetEnumerator(bool allowRemove) {
            return this.Rows.All.GetEnumerator();
        }
        protected override bool HasSchemaChanged() {
            return ((this.columnCount) == (this.Columns.Count));
        }
        private void InitClass() {
            this.columnCount = 11;
            this.columnCustomerID = new customers_CustomerID();
            this.Columns.Add(this.columnCustomerID);
            this.columnCompanyName = new customers_CompanyName();
            this.Columns.Add(this.columnCompanyName);
            this.columnContactName = new customers_ContactName();
            this.Columns.Add(this.columnContactName);
            this.columnContactTitle = new customers_ContactTitle();
            this.Columns.Add(this.columnContactTitle);
            this.columnAddress = new customers_Address();
            this.Columns.Add(this.columnAddress);
            this.columnCity = new customers_City();
            this.Columns.Add(this.columnCity);
            this.columnRegion = new customers_Region();
            this.Columns.Add(this.columnRegion);
            this.columnPostalCode = new customers_PostalCode();
            this.Columns.Add(this.columnPostalCode);
            this.columnCountry = new customers_Country();
            this.Columns.Add(this.columnCountry);
            this.columnPhone = new customers_Phone();
            this.Columns.Add(this.columnPhone);
            this.columnFax = new customers_Fax();
            this.Columns.Add(this.columnFax);
            this.PrimaryKey = System.Data.DataTable.CreateColumnArray(this.columnCustomerID);
            this.indexByCustomerID = System.Data.DataTable.CreateColumnArray(this.columnCustomerID);
        }
        public virtual customersRow NewcustomersRow() {
            return (customersRow)(this.NewRow());
        }
        protected override DataRow NewRowFromBuilder(DataRowBuilder builder) {
            /*We need to ensure that all Rows in the tabled are typed rows.*/
            /*Table calls newRow whenever it needs to create a row.*/
            /*So the following conditions are covered by Row newRow(Record record)*/
            /** Cursor calls table.addRecord(record) */
            /** table.addRow(object[] values) calls newRow(record)    */
            return new customersRow(builder);
        }
        protected override void OnRemoveColumn(DataColumn column) {
            if (((((((((((((((((((((((column) == (this.columnCustomerID))) || (((column) == (this.columnCompanyName))))) || (((column) == (this.columnContactName))))) || (((column) == (this.columnContactTitle))))) || (((column) == (this.columnAddress))))) || (((column) == (this.columnCity))))) || (((column) == (this.columnRegion))))) || (((column) == (this.columnPostalCode))))) || (((column) == (this.columnCountry))))) || (((column) == (this.columnPhone))))) || (((column) == (this.columnFax))))) {
                throw new ArgumentException("Can't remove column since it it built in to this dataSet");
            }
        }
        protected override void OnRowChanged(DataRowChangeEventArgs e) {
            base.OnRowChanged(e);
            if (((this.customersRowChanged) != (null))) {
                this.customersRowChanged(this, new customersRowChangeEvent((customersRow)(e.Row), e.Action));
            }
        }
        protected override void OnRowChanging(DataRowChangeEventArgs e) {
            if (((this.customersRowChanging) != (null))) {
                this.customersRowChanging(this, new customersRowChangeEvent((customersRow)(e.Row), e.Action));
            }
        }
        protected virtual void OnCustomerIDColumnChanging(DataColumnChangeEventArgs e) {
            if (((this.CustomerIDColumnChanging) != (null))) {
                this.CustomerIDColumnChanging(this, e);
            }
        }
        protected virtual void OnCompanyNameColumnChanging(DataColumnChangeEventArgs e) {
            if (((this.CompanyNameColumnChanging) != (null))) {
                this.CompanyNameColumnChanging(this, e);
            }
        }
        protected virtual void OnContactNameColumnChanging(DataColumnChangeEventArgs e) {
            if (((this.ContactNameColumnChanging) != (null))) {
                this.ContactNameColumnChanging(this, e);
            }
        }
        protected virtual void OnContactTitleColumnChanging(DataColumnChangeEventArgs e) {
            if (((this.ContactTitleColumnChanging) != (null))) {
                this.ContactTitleColumnChanging(this, e);
            }
        }
        protected virtual void OnAddressColumnChanging(DataColumnChangeEventArgs e) {
            if (((this.AddressColumnChanging) != (null))) {
                this.AddressColumnChanging(this, e);
            }
        }
        protected virtual void OnCityColumnChanging(DataColumnChangeEventArgs e) {
            if (((this.CityColumnChanging) != (null))) {
                this.CityColumnChanging(this, e);
            }
        }
        protected virtual void OnRegionColumnChanging(DataColumnChangeEventArgs e) {
            if (((this.RegionColumnChanging) != (null))) {
                this.RegionColumnChanging(this, e);
            }
        }
        protected virtual void OnPostalCodeColumnChanging(DataColumnChangeEventArgs e) {
            if (((this.PostalCodeColumnChanging) != (null))) {
                this.PostalCodeColumnChanging(this, e);
            }
        }
        protected virtual void OnCountryColumnChanging(DataColumnChangeEventArgs e) {
            if (((this.CountryColumnChanging) != (null))) {
                this.CountryColumnChanging(this, e);
            }
        }
        protected virtual void OnPhoneColumnChanging(DataColumnChangeEventArgs e) {
            if (((this.PhoneColumnChanging) != (null))) {
                this.PhoneColumnChanging(this, e);
            }
        }
        protected virtual void OnFaxColumnChanging(DataColumnChangeEventArgs e) {
            if (((this.FaxColumnChanging) != (null))) {
                this.FaxColumnChanging(this, e);
            }
        }
        protected override void OnColumnChanging(DataColumnChangeEventArgs e) {
            base.OnColumnChanging(e);
            if (((e.Column) == (this.columnCustomerID))) {
                this.OnCustomerIDColumnChanging(e);
            }
            else {
                if (((e.Column) == (this.columnCompanyName))) {
                    this.OnCompanyNameColumnChanging(e);
                }
                else {
                    if (((e.Column) == (this.columnContactName))) {
                        this.OnContactNameColumnChanging(e);
                    }
                    else {
                        if (((e.Column) == (this.columnContactTitle))) {
                            this.OnContactTitleColumnChanging(e);
                        }
                        else {
                            if (((e.Column) == (this.columnAddress))) {
                                this.OnAddressColumnChanging(e);
                            }
                            else {
                                if (((e.Column) == (this.columnCity))) {
                                    this.OnCityColumnChanging(e);
                                }
                                else {
                                    if (((e.Column) == (this.columnRegion))) {
                                        this.OnRegionColumnChanging(e);
                                    }
                                    else {
                                        if (((e.Column) == (this.columnPostalCode))) {
                                            this.OnPostalCodeColumnChanging(e);
                                        }
                                        else {
                                            if (((e.Column) == (this.columnCountry))) {
                                                this.OnCountryColumnChanging(e);
                                            }
                                            else {
                                                if (((e.Column) == (this.columnPhone))) {
                                                    this.OnPhoneColumnChanging(e);
                                                }
                                                else {
                                                    if (((e.Column) == (this.columnFax))) {
                                                        this.OnFaxColumnChanging(e);
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
        public virtual void RemovecustomersRow(customersRow rowcustomersRow) {
            this.Rows.Remove(rowcustomersRow);
        }
        public override bool ShouldPersistPrimaryKey() {
            return false;
        }
        public override void ResetPrimaryKey() {
        }
        
    }
    public class customers_CustomerID : System.Data.DataColumn {
        public customers_CustomerID() : 
                base("CustomerID", typeof(string)) {
            this.InitClass();
        }
        
        public virtual void InitClass() {
            this.AllowNull = false;
            this.Unique = true;
        }
        
    }
    public class customers_CompanyName : System.Data.DataColumn {
        public customers_CompanyName() : 
                base("CompanyName", typeof(string)) {
            this.InitClass();
        }
        
        public virtual void InitClass() {
            this.AllowNull = false;
        }
        
    }
    public class customers_ContactName : System.Data.DataColumn {
        public customers_ContactName() : 
                base("ContactName", typeof(string)) {
            this.InitClass();
        }
        
        public virtual void InitClass() {
        }
        
    }
    public class customers_ContactTitle : System.Data.DataColumn {
        public customers_ContactTitle() : 
                base("ContactTitle", typeof(string)) {
            this.InitClass();
        }
        
        public virtual void InitClass() {
        }
        
    }
    public class customers_Address : System.Data.DataColumn {
        public customers_Address() : 
                base("Address", typeof(string)) {
            this.InitClass();
        }
        
        public virtual void InitClass() {
        }
        
    }
    public class customers_City : System.Data.DataColumn {
        public customers_City() : 
                base("City", typeof(string)) {
            this.InitClass();
        }
        
        public virtual void InitClass() {
        }
        
    }
    public class customers_Region : System.Data.DataColumn {
        public customers_Region() : 
                base("Region", typeof(string)) {
            this.InitClass();
        }
        
        public virtual void InitClass() {
        }
        
    }
    public class customers_PostalCode : System.Data.DataColumn {
        public customers_PostalCode() : 
                base("PostalCode", typeof(string)) {
            this.InitClass();
        }
        
        public virtual void InitClass() {
        }
        
    }
    public class customers_Country : System.Data.DataColumn {
        public customers_Country() : 
                base("Country", typeof(string)) {
            this.InitClass();
        }
        
        public virtual void InitClass() {
        }
        
    }
    public class customers_Phone : System.Data.DataColumn {
        public customers_Phone() : 
                base("Phone", typeof(string)) {
            this.InitClass();
        }
        
        public virtual void InitClass() {
        }
        
    }
    public class customers_Fax : System.Data.DataColumn {
        public customers_Fax() : 
                base("Fax", typeof(string)) {
            this.InitClass();
        }
        
        public virtual void InitClass() {
        }
        
    }
    public class customersRow : DataRow {
        private customers tablecustomers;
        
        public customersRow(DataRowBuilder rb) : 
                base(rb) {
            this.tablecustomers = (customers)(this.Table);
        }
        
        public string CustomerID {
            virtual get {
                return (string)(this[this.tablecustomers.CustomerIDColumn]);
            }
            virtual set {
                this[this.tablecustomers.CustomerIDColumn] = value;
            }
        }
        public string CompanyName {
            virtual get {
                return (string)(this[this.tablecustomers.CompanyNameColumn]);
            }
            virtual set {
                this[this.tablecustomers.CompanyNameColumn] = value;
            }
        }
        public string ContactName {
            virtual get {
                return (string)(this[this.tablecustomers.ContactNameColumn]);
            }
            virtual set {
                this[this.tablecustomers.ContactNameColumn] = value;
            }
        }
        public bool ContactNameIsNull {
            virtual get {
                return this.IsNull(this.tablecustomers.ContactNameColumn);
            }
            virtual set {
                if (((value) == (true))) {
                    this[this.tablecustomers.ContactNameColumn] = Convert.DBNull;
                }
                else {
                    throw new ArgumentException("Can only set this property to true");
                }
            }
        }
        public string ContactTitle {
            virtual get {
                return (string)(this[this.tablecustomers.ContactTitleColumn]);
            }
            virtual set {
                this[this.tablecustomers.ContactTitleColumn] = value;
            }
        }
        public bool ContactTitleIsNull {
            virtual get {
                return this.IsNull(this.tablecustomers.ContactTitleColumn);
            }
            virtual set {
                if (((value) == (true))) {
                    this[this.tablecustomers.ContactTitleColumn] = Convert.DBNull;
                }
                else {
                    throw new ArgumentException("Can only set this property to true");
                }
            }
        }
        public string Address {
            virtual get {
                return (string)(this[this.tablecustomers.AddressColumn]);
            }
            virtual set {
                this[this.tablecustomers.AddressColumn] = value;
            }
        }
        public bool AddressIsNull {
            virtual get {
                return this.IsNull(this.tablecustomers.AddressColumn);
            }
            virtual set {
                if (((value) == (true))) {
                    this[this.tablecustomers.AddressColumn] = Convert.DBNull;
                }
                else {
                    throw new ArgumentException("Can only set this property to true");
                }
            }
        }
        public string City {
            virtual get {
                return (string)(this[this.tablecustomers.CityColumn]);
            }
            virtual set {
                this[this.tablecustomers.CityColumn] = value;
            }
        }
        public bool CityIsNull {
            virtual get {
                return this.IsNull(this.tablecustomers.CityColumn);
            }
            virtual set {
                if (((value) == (true))) {
                    this[this.tablecustomers.CityColumn] = Convert.DBNull;
                }
                else {
                    throw new ArgumentException("Can only set this property to true");
                }
            }
        }
        public string Region {
            virtual get {
                return (string)(this[this.tablecustomers.RegionColumn]);
            }
            virtual set {
                this[this.tablecustomers.RegionColumn] = value;
            }
        }
        public bool RegionIsNull {
            virtual get {
                return this.IsNull(this.tablecustomers.RegionColumn);
            }
            virtual set {
                if (((value) == (true))) {
                    this[this.tablecustomers.RegionColumn] = Convert.DBNull;
                }
                else {
                    throw new ArgumentException("Can only set this property to true");
                }
            }
        }
        public string PostalCode {
            virtual get {
                return (string)(this[this.tablecustomers.PostalCodeColumn]);
            }
            virtual set {
                this[this.tablecustomers.PostalCodeColumn] = value;
            }
        }
        public bool PostalCodeIsNull {
            virtual get {
                return this.IsNull(this.tablecustomers.PostalCodeColumn);
            }
            virtual set {
                if (((value) == (true))) {
                    this[this.tablecustomers.PostalCodeColumn] = Convert.DBNull;
                }
                else {
                    throw new ArgumentException("Can only set this property to true");
                }
            }
        }
        public string Country {
            virtual get {
                return (string)(this[this.tablecustomers.CountryColumn]);
            }
            virtual set {
                this[this.tablecustomers.CountryColumn] = value;
            }
        }
        public bool CountryIsNull {
            virtual get {
                return this.IsNull(this.tablecustomers.CountryColumn);
            }
            virtual set {
                if (((value) == (true))) {
                    this[this.tablecustomers.CountryColumn] = Convert.DBNull;
                }
                else {
                    throw new ArgumentException("Can only set this property to true");
                }
            }
        }
        public string Phone {
            virtual get {
                return (string)(this[this.tablecustomers.PhoneColumn]);
            }
            virtual set {
                this[this.tablecustomers.PhoneColumn] = value;
            }
        }
        public bool PhoneIsNull {
            virtual get {
                return this.IsNull(this.tablecustomers.PhoneColumn);
            }
            virtual set {
                if (((value) == (true))) {
                    this[this.tablecustomers.PhoneColumn] = Convert.DBNull;
                }
                else {
                    throw new ArgumentException("Can only set this property to true");
                }
            }
        }
        public string Fax {
            virtual get {
                return (string)(this[this.tablecustomers.FaxColumn]);
            }
            virtual set {
                this[this.tablecustomers.FaxColumn] = value;
            }
        }
        public bool FaxIsNull {
            virtual get {
                return this.IsNull(this.tablecustomers.FaxColumn);
            }
            virtual set {
                if (((value) == (true))) {
                    this[this.tablecustomers.FaxColumn] = Convert.DBNull;
                }
                else {
                    throw new ArgumentException("Can only set this property to true");
                }
            }
        }
        
    }
    public class customersRowChangeEvent : EventArgs {
        private customersRow rowcustomersRow;
        private System.Data.DataRowAction actionValue;
        
        internal customersRowChangeEvent(customersRow rowcustomersRowArg, DataRowAction actionArg) {
            this.rowcustomersRow = rowcustomersRowArg;
            this.actionValue = actionArg;
        }
        
        public customersRow customersRow {
            virtual get {
                return this.rowcustomersRow;
            }
        }
        public DataRowAction Action {
            virtual get {
                return this.actionValue;
            }
        }
        
    }
    public delegate void customersRowChangeEventHandler(object sender, customersRowChangeEvent Event);
}
